import processing.serial.*;
import processing.core.*; 
import fullscreen.*;  //um im Vollbildmodus starten zu können.
import codeanticode.gsvideo.*;

Serial myPort;  // Create object from Serial class
GSCapture webcam;


void setup() 
{
  size(displayWidth, displayHeight);
  
  //Vorher symbolischen Link erzeugen:
  //ln -s  /dev/ttyACM0 /dev/ttyS80
  //ev. ändert sich der Port:  
  //ln -s  /dev/ttyACM1 /dev/ttyS81  
  //Lockdatei ev. von hand löschen:
  //sudo rm -f /var/lock/LCK..ttyS81    

  //delay(2000);
  myPort = new Serial(this,"/dev/ttyS81", 9600);    

  webcam = new GSCapture(this,640,480,"/dev/video0");
  //delay(2000);
  if(webcam!=null)  
      webcam.start();
  
  //delay(2000);
  frameRate(10);
  (new FullScreen(this)).enter();
}


void draw()
{
  clear();
  //background(0);
  fill(0);
  rect(0, 0, displayWidth, displayHeight);

  if ( myPort.available() >= 1) 
  {
      int PWM = (mouseX*40)/displayWidth;
      myPort.write(PWM);
      stroke(0,255,0);
      fill(0,255,0);
      text("PWM="+(PWM-20),20,displayHeight/2);

  }
  else
  {
      fill(0,0,255);
      stroke(0,0,255);
  }
  
  if(webcam!=null && webcam.available())
  {
     webcam.read();
     set(displayWidth-640,displayHeight-480,webcam);
  }
  
  line(mouseX,displayHeight/2,mouseX,displayHeight);      

    
}

